STOFFChart Class Reference documentation

Classes | Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | Private Member Functions | Friends | List of all members
STOFFChart Class Referenceabstract

a class used to store a chart associated to a spreadsheet .... More...

`#include <STOFFChart.hxx>`

Inheritance diagram for STOFFChart:

## Classes
struct | Axis
struct | Legend
| a legend in a chart More...
struct | Position
| a cell position More...
struct | Serie
| a serie in a chart More...
struct | TextZone
| a text zone a chart More...

## Public Member Functions
| STOFFChart (STOFFVec2f const &dim=STOFFVec2f())
| the constructor More...
virtual | ~STOFFChart ()
| the destructor More...
void | sendChart (STOFFSpreadsheetListenerPtr &listener, librevenge::RVNGSpreadsheetInterface *interface)
| send the chart to the listener More...
virtual void | sendContent (TextZone const &zone, STOFFListenerPtr &listener) const =0
| send the zone content (called when the zone is of text type) More...
void | setGridColor (STOFFColor const &color)
| set the grid color More...
Axis & | getAxis (int coord)
| return an axis (corresponding to a coord) More...
Axis const & | getAxis (int coord) const
| return an axis (corresponding to a coord) More...
Legend const & | getLegend () const
| returns the legend More...
Legend & | getLegend ()
| returns the legend More...
Serie * | getSerie (int id, bool create)
| return a serie More...
std::map< int, Serie > const & | getIdSerieMap () const
| returns the list of defined series More...
TextZone * | getTextZone (TextZone::Type type, bool create=false)
| returns a textzone content More...

## Public Attributes
STOFFVec2f | m_dimension
| the chart dimension in point More...
Serie::Type | m_type
| the chart type (if no series) More...
bool | m_dataStacked
| a flag to know if the data are stacked or not More...
bool | m_dataPercentStacked
| a flag to know if the data are percent stacked or not More...
bool | m_dataVertical
| a flag to know if the data are vertical (for bar) More...
bool | m_is3D
| a flag to know if the graphic is 3D More...
bool | m_is3DDeep
| a flag to know if real 3D or 2D-extended More...
STOFFGraphicStyle | m_style
| the chart style More...
librevenge::RVNGString | m_name
| the chart name More...
STOFFBox2f | m_plotAreaPosition
| the plot area dimension in percent More...
STOFFGraphicStyle | m_plotAreaStyle
| the ploat area style More...
STOFFBox2f | m_legendPosition
| the legend dimension in percent More...
STOFFGraphicStyle | m_floorStyle
| floor More...
STOFFGraphicStyle | m_wallStyle
| wall More...

## Protected Member Functions
void | sendTextZoneContent (TextZone::Type type, STOFFListenerPtr &listener) const
| sends a textzone content More...

## Protected Attributes
STOFFColor | m_gridColor
| the grid color More...
Axis | m_axis [5]
| the x,y,y-second,z and a bad axis More...
Legend | m_legend
| the legend More...
std::map< int, Serie > | m_serieMap
| the list of series More...
std::map< TextZone::Type, TextZone > | m_textZoneMap
| a map text zone type to text zone More...

## Private Member Functions
| STOFFChart (STOFFChart const &orig)=delete
STOFFChart & | operator= (STOFFChart const &orig)=delete

## Friends
class | STOFFChartInternal::SubDocument

## Detailed Description

a class used to store a chart associated to a spreadsheet ....

## Constructor & Destructor Documentation

## ◆ STOFFChart() [1/2]

STOFFChart::STOFFChart | ( | STOFFVec2f const & | dim = `STOFFVec2f()` | ) |

the constructor

## ◆ ~STOFFChart()

STOFFChart::~STOFFChart | ( |  | ) |
| virtual

the destructor

## ◆ STOFFChart() [2/2]

STOFFChart::STOFFChart | ( | STOFFChart const & | orig | ) |
| explicitprivatedelete

## Member Function Documentation

## ◆ getAxis() [1/2]

STOFFChart::Axis & STOFFChart::getAxis | ( | int | coord | ) |

return an axis (corresponding to a coord)

## ◆ getAxis() [2/2]

STOFFChart::Axis const & STOFFChart::getAxis | ( | int | coord | ) | const

return an axis (corresponding to a coord)

## ◆ getIdSerieMap()

std::map< int, Serie > const & STOFFChart::getIdSerieMap | ( |  | ) | const
| inline

returns the list of defined series

## ◆ getLegend() [1/2]

Legend & STOFFChart::getLegend | ( |  | ) |
| inline

returns the legend

## ◆ getLegend() [2/2]

Legend const & STOFFChart::getLegend | ( |  | ) | const
| inline

returns the legend

## ◆ getSerie()

STOFFChart::Serie * STOFFChart::getSerie | ( | int | id,
|  | bool | create
| ) |  |

return a serie

## ◆ getTextZone()

STOFFChart::TextZone * STOFFChart::getTextZone | ( | TextZone::Type | type,
|  | bool | create = `false`
| ) |  |

returns a textzone content

## ◆ operator=()

STOFFChart & STOFFChart::operator= | ( | STOFFChart const & | orig | ) |
| privatedelete

## ◆ sendChart()

void STOFFChart::sendChart | ( | STOFFSpreadsheetListenerPtr & | listener,
|  | librevenge::RVNGSpreadsheetInterface * | interface
| ) |  |

send the chart to the listener

Referenced by STOFFSpreadsheetListener::insertChart().

## ◆ sendContent()

virtual void STOFFChart::sendContent | ( | TextZone const & | zone,
|  | STOFFListenerPtr & | listener
| ) |  | const
| pure virtual

send the zone content (called when the zone is of text type)

Implemented in StarObjectChartInternal::Chart.

Referenced by sendTextZoneContent().

## ◆ sendTextZoneContent()

void STOFFChart::sendTextZoneContent | ( | TextZone::Type | type,
|  | STOFFListenerPtr & | listener
| ) |  | const
| protected

sends a textzone content

Referenced by STOFFChartInternal::SubDocument::parse().

## ◆ setGridColor()

void STOFFChart::setGridColor | ( | STOFFColor const & | color | ) |
| inline

set the grid color

## Friends And Related Function Documentation

## ◆ STOFFChartInternal::SubDocument

friend class STOFFChartInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_axis

Axis STOFFChart::m_axis[5]
| protected

the x,y,y-second,z and a bad axis

Referenced by getAxis(), and sendChart().

## ◆ m_dataPercentStacked

bool STOFFChart::m_dataPercentStacked

a flag to know if the data are percent stacked or not

Referenced by sendChart().

## ◆ m_dataStacked

bool STOFFChart::m_dataStacked

a flag to know if the data are stacked or not

Referenced by sendChart().

## ◆ m_dataVertical

bool STOFFChart::m_dataVertical

a flag to know if the data are vertical (for bar)

Referenced by sendChart().

## ◆ m_dimension

STOFFVec2f STOFFChart::m_dimension

the chart dimension in point

Referenced by sendChart().

## ◆ m_floorStyle

STOFFGraphicStyle STOFFChart::m_floorStyle

floor

Referenced by sendChart().

## ◆ m_gridColor

STOFFColor STOFFChart::m_gridColor
| protected

the grid color

Referenced by setGridColor().

## ◆ m_is3D

bool STOFFChart::m_is3D

a flag to know if the graphic is 3D

Referenced by sendChart().

## ◆ m_is3DDeep

bool STOFFChart::m_is3DDeep

a flag to know if real 3D or 2D-extended

Referenced by sendChart().

## ◆ m_legend

Legend STOFFChart::m_legend
| protected

the legend

Referenced by getLegend(), and sendChart().

## ◆ m_legendPosition

STOFFBox2f STOFFChart::m_legendPosition

the legend dimension in percent

Referenced by sendChart().

## ◆ m_name

librevenge::RVNGString STOFFChart::m_name

the chart name

## ◆ m_plotAreaPosition

STOFFBox2f STOFFChart::m_plotAreaPosition

the plot area dimension in percent

Referenced by sendChart().

## ◆ m_plotAreaStyle

STOFFGraphicStyle STOFFChart::m_plotAreaStyle

the ploat area style

Referenced by sendChart().

## ◆ m_serieMap

std::map<int, Serie> STOFFChart::m_serieMap
| protected

the list of series

Referenced by getIdSerieMap(), getSerie(), and sendChart().

## ◆ m_style

STOFFGraphicStyle STOFFChart::m_style

the chart style

Referenced by STOFFChart::Axis::addStyleTo(), STOFFChart::Legend::addStyleTo(), STOFFChart::Serie::addStyleTo(), STOFFChart::TextZone::addStyleTo(), and sendChart().

## ◆ m_textZoneMap

std::map<TextZone::Type, TextZone> STOFFChart::m_textZoneMap
| protected

a map text zone type to text zone

Referenced by getTextZone(), sendChart(), and sendTextZoneContent().

## ◆ m_type

Serie::Type STOFFChart::m_type

the chart type (if no series)

Referenced by STOFFChart::Axis::addContentTo(), STOFFChart::Serie::addContentTo(), STOFFChart::TextZone::addContentTo(), STOFFChart::Axis::addStyleTo(), and sendChart().

## ◆ m_wallStyle

STOFFGraphicStyle STOFFChart::m_wallStyle

wall

Referenced by sendChart().

The documentation for this class was generated from the following files:

- STOFFChart.hxx
- STOFFChart.cxx